<template>
	<view class="content">
		<view class="navbar">
			<view v-for="(item, index) in navList" :key="index" class="nav-item" :class="{ current: tabCurrentIndex === index }" @click="tabClick(index)">{{ item.text }}</view>
		</view>

		<swiper :current="tabCurrentIndex" class="swiper-box" duration="300" @change="changeTab">
			<swiper-item class="tab-content" v-for="(tabItem, tabIndex) in navList" :key="tabIndex">
				<scroll-view class="list-scroll-content" scroll-y @scrolltolower="loadData">
					<!-- 空白页 -->
					<empty v-if="tabItem.loaded === true && tabItem.orderList.length === 0"></empty>

					<!-- 订单列表 -->
					<view @click="goToOrderDetail(item)" v-for="(item, index) in navList[tabCurrentIndex].orderList" :key="index" class="order-item">
						<view v-if="item._status._title != '未支付'">
							<view class="i-top b-b">
								<text class="time">订单编号：{{ item.order_id }}</text>
								<text class="state" style="color: #999999;;">{{ item._status._title != '未发货' ? '拼团成功' : '正在拼团' }}</text>
								<!-- <text v-if="item.status === 3" class="del-btn iconfont icondelete" @click="deleteOrder(index)"></text> -->
							</view>
							<view class="flex_item assemble_box">
								<view class="goods-box">
									<view class="goods-item"><image class="goods-img" :src="item.cartInfo[0].productInfo.image" mode=" scaleToFill"></image></view>
								</view>
								<view class="assemble">
									<view class="assemble_title">{{ item.cartInfo[0].productInfo.store_name }}</view>
									<view class="flex_item assemble_avatar clamp">
										<template v-for="it in item.imgs">
											<image :src="'https://cgst.liuniu946.com/image/' + it + '.jpg'" mode="" :key="it"></image>
										</template>
										<view style="position: relative; top: 8rpx;"><image :src="userInfo.avatar || '/static/error/missing-face.png'"></image></view>
										<view class="slh" style="position: relative; top: 10rpx; left: 6rpx" v-if="item.pink_num > 5">...</view>
									</view>
									<view class="assemble_text">共4人参与了拼团，拼团人数齐了</view>
								</view>
							</view>
							<view class="action-box b-t" v-if="item._status._title != '未发货'">
								<view class="action-box-left">
									<view class="itemText recom" :class="{ chayidian: item.is_refund == 1 }"><template></template></view>
								</view>
								<view class="action-btn" @click.stop="navTo(item)">查看卡券</view>
							</view>
						</view>
						<view v-else>
							<view class="i-top b-b">
								<text class="time">{{ item._add_time }}</text>
								<text class="state" :style="{ color: item.stateTipColor }">{{ item._status._title }}</text>
								<text v-if="item.status === 4" class="del-btn iconfont icondelete" @click="deleteOrder(index)"></text>
							</view>

							<scroll-view v-if="item.cartInfo.length > 1" class="goods-box" scroll-x>
								<view v-for="(goodsItem, goodsIndex) in item.cartInfo" :key="goodsIndex" class="goods-item">
									<image class="goods-img" :src="goodsItem.productInfo.image" mode="aspectFill"></image>
								</view>
							</scroll-view>
							<view class="goods-box-single" v-for="(goodsItem, goodsIndex) in item.cartInfo" :key="goodsIndex">
								<image class="goods-img" :src="goodsItem.productInfo.image" mode="scaleToFill"></image>
								<view class="right">
									<view class="flex-start">
										<text class="title clamp">{{ goodsItem.productInfo.store_name }}</text>
										<text class="price">{{ 1 * goodsItem.productInfo.price }}</text>
									</view>
									<view class="row flex">
										<text class="row_title">{{ goodsItem.productInfo.attrInfo ? goodsItem.productInfo.attrInfo.suk : '' }}</text>
										<text class="attr-box">x {{ goodsItem.cart_num }}</text>
									</view>
								</view>
							</view>

							<view class="price-box">
								共
								<text class="num">{{ item.cartInfo.length }}</text>
								件商品 邮费
								<text class="price">{{ 1 * item.pay_postage }}</text>
								实付款
								<text class="price">{{ item.pay_price * 1 }}</text>
							</view>
							<view class="action-box b-t" v-if="item.status != 5">
								<button v-if="item._status._title == '未支付'" class="action-btn" @click.stop="cancelOrder(item)">取消订单</button>
								<button v-if="item._status._title == '未支付'" @click.stop="orderPay(item)" class="action-btn ">立即支付</button>
							</view>
						</view>
					</view>
					<uni-load-more :status="tabItem.loadingType"></uni-load-more>
				</scroll-view>
			</swiper-item>
		</swiper>
	</view>
</template>

<script>
import uniLoadMore from '@/components/uni-load-more/uni-load-more.vue';
import empty from '@/components/empty';
import { mapState } from 'vuex';
import { saveUrl } from '@/utils/loginUtils.js';
import { orderList, orderCancel, orderDel, orderTake, refundList } from '@/api/order.js';
export default {
	filters: {
		// 过滤金额为数字
		moneyNum: function(value) {
			return +value;
		}
	},
	components: {
		uniLoadMore,
		empty
	},
	data() {
		return {
			tabCurrentIndex: 0,
			state: '',
			showModal: false,
			limit: 10,
			page: 1,
			navList: [
				{
					state: '',
					text: '全部订单',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				{
					state: 1,
					text: '正在拼团',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				{
					state: 0,
					text: '待付款',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				{
					state: 3,
					text: '已完成',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				}
			]
		};
	},

	onLoad(options) {
		this.state = options.state;
		saveUrl();
		/**
		 * 修复app端点击除全部订单外的按钮进入时不加载数据的问题
		 * 替换onLoad下代码即可
		 */
		this.tabCurrentIndex = +options.state;
		// #ifndef MP
		this.loadData();
		// #endif
		// #ifdef MP
		if (options.state == 0) {
			this.loadData();
		}
		// #endif
	},
	computed: {
		...mapState(['userInfo'])
	},
	methods: {
		//取消订单
		cancelOrder(item) {
			uni.showModal({
				title: '订单取消',
				content: '是否取消订单？',
				success: e => {
					if (e.confirm) {
						uni.showLoading({
							title: '请稍后'
						});
						orderCancel({ id: item.order_id })
							.then(e => {
								uni.showToast({
									title: '取消成功',
									duration: 2000,
									position: 'top'
								});
							})
							.catch(e => {
								console.log(e);
							});
						//取消订单后删除待付款中该项
						let list = this.navList[this.tabCurrentIndex].orderList;
						let index = list.findIndex(val => val.id === item.id);
						index !== -1 && list.splice(index, 1);
						uni.hideLoading();
					}
				}
			});
		},
		// 跳转到查询快递页面
		expressCheck(item) {
			console.log(item);
			uni.navigateTo({
				url: '/pages/order/expressInfo?id=' + item.id
				// url: '/pages/order/expressInfo?id=' +item.order_id
			});
		},

		//跳转到订单详情
		goToOrderDetail(e) {
			uni.navigateTo({
				url: '/pages/order/orderDetail?id=' + e.order_id
			});
		},

		//分享
		share(e) {
			console.log(e);
			uni.navigateTo({
				url: '/pages/product/details?pink_id=' + e.pink_id
			});
		},
		navTo(e) {
			console.log(e, '123456');
			uni.navigateTo({
				url: '/pages/user/myyhq?order_id=' + e.id
			});
		},
		// 订单支付
		orderPay(e) {
			if (e.combination_id > 0) {
				uni.navigateTo({
					url: '/pages/money/pay?type=1&ordid=' + e.order_id + '&money=' + e.pay_price + '&goodsType=2'
				});
			} else {
				uni.navigateTo({
					url: '/pages/money/pay?type=1&ordid=' + e.order_id + '&money=' + e.pay_price
				});
			}
		},
		//获取订单列表
		loadData(source) {
			//这里是将订单挂载到tab列表下
			let index = this.tabCurrentIndex;
			let navItem = this.navList[index];
			let state = navItem.state;
			const obj = this;
			if (source === 'tabChange' && navItem.loaded === true) {
				//tab切换只有第一次需要加载数据
				return;
			}
			if (navItem.loadingType === 'loading') {
				//防止重复加载
				return;
			}
			if (navItem.loadingType === 'noMore') {
				//防止重复加载
				return;
			}
			// 修改当前对象状态为加载中
			navItem.loadingType = 'loading';
			orderList({
				type: state,
				page: navItem.page,
				limit: 10
			})
				.then(({ data }) => {
					let arr = data.map(e => {
						e.imgs = this.getSJ(3);
						// let b = this.orderStateExp(e.status);
						// e.stateTip = b.stateTip;
						// e.stateTipColor = b.stateTipColor;
						return e;
					});
					navItem.orderList = navItem.orderList.concat(arr);
					// console.log(navItem.orderList);
					navItem.page++;
					if (navItem.limit == data.length) {
						//判断是否还有数据， 有改为 more， 没有改为noMore
						navItem.loadingType = 'more';
						return;
					} else {
						//判断是否还有数据， 有改为 more， 没有改为noMore
						console.log(navItem.state);
						navItem.loadingType = 'noMore';
					}
					this.$set(navItem, 'loaded', true);
				})
				.catch(e => {
					console.log(e);
				});
		},
		//swiper 切换
		changeTab(e) {
			console.log(e, 'tabChange');
			this.tabCurrentIndex = e.target.current;
			this.loadData('tabChange');
		},
		//顶部tab点击
		tabClick(index) {
			this.tabCurrentIndex = index;
			this.loadData('tabChange');
		},
		//获取N个随机数
		getSJ(n) {
			let arr = [];
			for (let i = 0; i < n; i++) {
				let a = Math.ceil(Math.random() * 16);
				arr = arr.concat(a);
			}
			return arr;
		},
		//订单状态文字和颜色
		orderStateExp(state) {
			let stateTip = '',
				stateTipColor = '#EF041F';
			switch (+state) {
				case 0:
					stateTip = '全部';
					break;
				case 1:
					stateTip = '待付款';
					break;
				case 2:
					stateTip = '待发货';
					break;
				case 3:
					stateTip = '待收货';
					break;
				case 4:
					stateTip = '已完成';
					stateTipColor = '#5dbc7c';
					break;
				case 9:
					stateTip = '订单已关闭';
					stateTipColor = '#909399';
					break;

				//更多自定义
			}
			return { stateTip, stateTipColor };
		}
	}
};
</script>

<style lang="scss">
page,
.content {
	background: $page-color-base;
	height: 100%;
}

.swiper-box {
	height: calc(100% - 40px);
	padding: 0 20rpx;
}
.list-scroll-content {
	height: 100%;
}

.navbar {
	display: flex;
	height: 40px;
	padding: 0 5px;
	background: #fff;
	box-shadow: 0 1px 5px rgba(0, 0, 0, 0.06);
	position: relative;
	z-index: 10;
	.nav-item {
		flex: 1;
		display: flex;
		justify-content: center;
		align-items: center;
		height: 100%;
		font-size: 15px;
		color: #6e6e6e;
		position: relative;
		&.current {
			font-weight: bolder;
			color: #333333;
			&:after {
				content: '';
				position: absolute;
				left: 50%;
				bottom: 0;
				transform: translateX(-50%);
				width: 44px;
				height: 0;
				border-bottom: 2px solid #ff0000;
			}
		}
	}
}

.uni-swiper-item {
	height: auto;
}
.order-item {
	display: flex;
	flex-direction: column;
	padding-left: 30rpx;
	background: #fff;
	margin-top: 16rpx;
	border-radius: 15rpx;
	.i-top {
		display: flex;
		align-items: center;
		height: 80rpx;
		padding-right: 30rpx;
		font-size: $font-base;
		color: $font-color-dark;
		position: relative;
		.time {
			flex: 1;
		}
		.state {
			color: $base-color;
		}
		.del-btn {
			padding: 10rpx 0 10rpx 36rpx;
			font-size: $font-lg;
			color: $font-color-light;
			position: relative;
			&:after {
				content: '';
				width: 0;
				height: 30rpx;
				border-left: 1px solid $border-color-dark;
				position: absolute;
				left: 20rpx;
				top: 50%;
				transform: translateY(-50%);
			}
		}
	}
	/* 多条商品 */
	.goods-box {
		height: 160rpx;
		padding: 20rpx 0;
		white-space: nowrap;
		.goods-item {
			width: 120rpx;
			height: 120rpx;
			display: inline-block;
			margin-right: 24rpx;
		}
		.goods-img {
			display: block;
			width: 100%;
			height: 100%;
		}
	}
	/* 单条商品 */
	.goods-box-single {
		display: flex;
		padding: 20rpx 0;
		.goods-img {
			display: block;
			width: 200rpx;
			height: 118rpx;
		}
		.right {
			flex: 1;
			display: flex;
			flex-direction: column;
			padding: 0 30rpx 0 24rpx;
			overflow: hidden;
			.title {
				font-size: $font-base + 2rpx;
				color: $font-color-dark;
				line-height: 1;
			}
			.attr-box {
				font-size: $font-sm + 2rpx;
				color: $font-color-light;
				padding: 10rpx 12rpx;
			}
			.price {
				font-size: $font-base + 2rpx;
				color: $font-color-dark;
				&:before {
					content: '￥';
					font-size: $font-sm;
					margin: 0 2rpx 0 8rpx;
				}
			}
		}
	}
	.assemble {
		padding: 15rpx;
		width: 80%;
	}
	.assemble_title {
		font-size: $font-base + 2rpx;
		color: $font-color-dark;
		white-space: nowrap;
		overflow: hidden;
		text-overflow: ellipsis;
	}
	.assemble image {
		width: 55rpx;
		height: 55rpx;
		margin-left: -15rpx;
		border: 2rpx solid #ffffff;
		border-radius: 50rpx;
	}
	.assemble_text {
		font-size: 24rpx;
		color: #999999;
	}
	.assemble_avatar {
		padding-left: 15rpx;
		padding-top: 10rpx;
	}
	.assemble_box {
		width: 100%;
		padding-right: 15rpx;
	}
	.price-box {
		display: flex;
		justify-content: flex-end;
		align-items: baseline;
		padding: 20rpx 30rpx;
		font-size: $font-sm + 2rpx;
		color: $font-color-light;
		.num {
			margin: 0 8rpx;
			color: $font-color-dark;
		}
		.price {
			font-size: $font-lg;
			color: $font-color-dark;
			&:before {
				content: '￥';
				font-size: $font-sm;
				margin: 0 2rpx 0 8rpx;
			}
		}
	}
	.action-box {
		display: flex;
		justify-content: space-between;
		align-items: center;
		height: 100rpx;
		position: relative;
		padding-right: 30rpx;
		.itemText {
			font-size: $font-sm;
			color: #fc4141;
		}
		.chayidian {
			color: #999999 !important;
		}
	}
	.action-btn {
		width: 160rpx;
		height: 60rpx;
		margin: 0;
		margin-left: 24rpx;
		padding: 0;
		text-align: center;
		line-height: 60rpx;
		font-size: $font-sm + 2rpx;
		color: #ff5b5b;
		background-color: #fff;
		border: 1px solid #ff5b5b;
		border-radius: 100px;
		&:after {
			border-radius: 100px;
		}
		&.recom {
			color: $font-color-base;
			background-color: #ffffff;

			&:after {
				border-color: $base-color;
			}
		}
		&.evaluate {
			color: $color-yellow;
			&:after {
				border-color: $color-yellow;
			}
		}
	}
}

// 积分投注弹窗
.mask {
	z-index: 10;
	position: fixed;
	top: 0;
	right: 0;
	bottom: 0;
	left: 0;
	background-color: rgba(0, 0, 0, 0.5);
	width: 100%;
	height: 100%;
	display: flex;
	justify-content: center;
	align-items: center;
	flex-direction: column;
	.pop {
		z-index: 12;
		width: 560rpx;
		height: 379rpx;
		background: rgba(255, 255, 255, 1);
		border-radius: 30px;
		.pop-box {
			width: 100%;
			height: 100%;
			display: flex;
			flex-direction: column;
			text-align: center;
			align-items: center;
			margin-top: -72rpx !important;
			.pop-img {
				width: 177rpx;
				height: 186rpx;
				margin-bottom: 34rpx;
			}
			.pop-title {
				height: 34rpx;
				font-size: 36rpx;
				font-weight: 500;
				color: rgba(51, 51, 51, 1);
				margin-bottom: 32rpx;
			}
			.number {
				width: 454rpx;
				height: 78rpx;
				background: rgba(234, 234, 234, 1);
				background: #eaeaea;
			}
		}
		//关闭按钮
		.close-box {
			margin-top: 130rpx;
			text-align: center;
			.close {
				width: 83rpx;
				height: 83rpx;
			}
		}
	}
}

/* load-more */
.uni-load-more {
	display: flex;
	flex-direction: row;
	height: 80rpx;
	align-items: center;
	justify-content: center;
}

.uni-load-more__text {
	font-size: 28rpx;
	color: #999;
}

.uni-load-more__img {
	height: 24px;
	width: 24px;
	margin-right: 10px;
}

.uni-load-more__img > view {
	position: absolute;
}

.uni-load-more__img > view view {
	width: 6px;
	height: 2px;
	border-top-left-radius: 1px;
	border-bottom-left-radius: 1px;
	background: #999;
	position: absolute;
	opacity: 0.2;
	transform-origin: 50%;
	animation: load 1.56s ease infinite;
}

.uni-load-more__img > view view:nth-child(1) {
	transform: rotate(90deg);
	top: 2px;
	left: 9px;
}

.uni-load-more__img > view view:nth-child(2) {
	transform: rotate(180deg);
	top: 11px;
	right: 0;
}

.uni-load-more__img > view view:nth-child(3) {
	transform: rotate(270deg);
	bottom: 2px;
	left: 9px;
}

.uni-load-more__img > view view:nth-child(4) {
	top: 11px;
	left: 0;
}

.load1,
.load2,
.load3 {
	height: 24px;
	width: 24px;
}

.load2 {
	transform: rotate(30deg);
}

.load3 {
	transform: rotate(60deg);
}

.load1 view:nth-child(1) {
	animation-delay: 0s;
}

.load2 view:nth-child(1) {
	animation-delay: 0.13s;
}

.load3 view:nth-child(1) {
	animation-delay: 0.26s;
}

.load1 view:nth-child(2) {
	animation-delay: 0.39s;
}

.load2 view:nth-child(2) {
	animation-delay: 0.52s;
}

.load3 view:nth-child(2) {
	animation-delay: 0.65s;
}

.load1 view:nth-child(3) {
	animation-delay: 0.78s;
}

.load2 view:nth-child(3) {
	animation-delay: 0.91s;
}

.load3 view:nth-child(3) {
	animation-delay: 1.04s;
}

.load1 view:nth-child(4) {
	animation-delay: 1.17s;
}

.load2 view:nth-child(4) {
	animation-delay: 1.3s;
}

.load3 view:nth-child(4) {
	animation-delay: 1.43s;
}

@-webkit-keyframes load {
	0% {
		opacity: 1;
	}

	100% {
		opacity: 0.2;
	}
}
</style>
